#version 120
//
// simple.frag
//
uniform vec3 pos[3], vec[3];
varying vec3 o, d;

void main(void)
{
  vec3 q = cross(d, pos[2]);
  float s = dot(q, pos[1]);
  
  if (s == 0.0) discard;
  
  vec3 e = o - pos[0]; 
  vec3 r = cross(e, pos[1]);
  float t = dot(r, pos[2]) / s;
  
  if (t < 0.0 || t > 1.0) discard;
  
  float u = dot(q, e) / s;
  float v = dot(r, d) / s;
  float w = 1.0 - u - v;

  if (any(lessThan(vec3(u, v, w), vec3(0.0)))) discard;

  vec3 n = normalize(w * vec[0] + u * vec[1] + v * vec[2]);

  gl_FragDepth = t;
  gl_FragColor = vec4(n.z, n.z, n.z, 1.0);
}
